'Unify function can be used by backward chaining program'
'Written by Amy Sliva for CS5100 Artificial Intelligence'
from FOLexp import *

def unify(FOLexp1, FOLexp2):
    'arguments are FOLexp instances'
    'return a substitution (list of var/term pairs) if they unify'
    'return false (python boolean) if not'
    return unify1 (FOLexp1, FOLexp2, [])

def unify1(f1, f2, theta):
  if theta == False:
      return theta
  elif f1.isConst() and f2.isConst():
      if f1.name == f2.name:
          return theta
      else:
          return False
  elif f1.isVar():
      return unifyVar(f1, f2, theta)
  elif f2.isVar():
      return unifyVar(f2, f1, theta)
  elif f2.isCompound() and f1.op == f2.op and \
          len(f1.args) == len(f2.args):
      for x, y in zip(f1.args, f2.args):
          theta = unify1(x, y, theta)
      return theta
  else:
      return False
                        
def unifyVar(var, f2, theta):
    if var.name == f2.name:
        return theta
    elif  occursIn(var, theta):
        return unify1(valOf(var,theta), f2, theta)
    elif f2.isVar() and occursIn(f2,theta):
        return unify1 (valOf(f2, theta), var, theta)
    elif f2.isCompound() and occurCheck(var, f2):
        return False
    else:
        # theta.append([var, f2])
        return compose([var, f2], theta)  # add new pair and update theta

def compose (newpair, theta):
    for pair in theta:
        if occurCheck(newpair[0], pair[1]):
	    pair[1] = subst([newpair], pair[1])
	    if occurCheck(pair[0], pair[1]):
	        return False  
    return [newpair] + theta

def subst(theta, f2):
    for pair in theta:
        f2 = subst1(pair, f2)
    return f2

def subst1(pair, f2):
    if f2.isVar():
       if f2.name == pair[0].name:
           return pair[1]
    elif f2.isCompound():
       f2.args = map(lambda x: subst1(pair, x), f2.args)
    return f2

def valOf(var, theta):
    for pair in theta:
        if var.name == pair[0].name:
            return pair[1]

def occursIn (var, theta):
    for pair in theta:
        if var.name == pair[0].name:
            return True
    return False

def occurCheck(var, f2):
    if f2.isVar():
        return var.name == f2.name
    elif f2.isCompound():
        for a in f2.args:
            if occurCheck(var, a):
                return True
    return False
#*****************************************************************
#  Two functions to make testing of unify easier

def unifyStr(s1, s2):
    return unify(FOLexp(s1), FOLexp(s2))

def printTheta (theta):
    if theta == False:
        print "Failed!"
    elif len(theta) == 0:
        print theta
    else:
        for pair in theta:
           print 'Var: ', pair[0], ' match: ' , pair[1]

